# ClpSimplex Class Reference

This solves LPs using the simplex method. More...

`#include <ClpSimplex.hpp>`

Inheritance diagram for ClpSimplex:
[legend]
Collaboration diagram for ClpSimplex:
[legend]

List of all members.

## Public Types
enum | Status { isFree = 0x00, basic = 0x01, atUpperBound = 0x02, atLowerBound = 0x03, superBasic = 0x04, isFixed = 0x05 }
| enums for status of various sorts. More...
enum | FakeBound { noFake = 0x00, lowerFake = 0x01, upperFake = 0x02, bothFake = 0x03 }
## Public Member Functions
Constructors and destructor and copy
| ClpSimplex (bool emptyMessages=false)
| Default constructor.
| ClpSimplex (const ClpSimplex &rhs, int scalingMode=-1)
| Copy constructor.
| ClpSimplex (const ClpModel &rhs, int scalingMode=-1)
| Copy constructor from model.
| ClpSimplex (const ClpModel *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor.
| ClpSimplex (const ClpSimplex *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor.
| ClpSimplex (ClpSimplex *wholeModel, int numberColumns, const int *whichColumns)
| This constructor modifies original ClpSimplex and stores original stuff in created ClpSimplex.
void | originalModel (ClpSimplex *miniModel)
| This copies back stuff from miniModel and then deletes miniModel.
int | abcState () const
| Default constructor.
void | setAbcState (int state)
| Default constructor.
void | setPersistenceFlag (int value)
| Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.
void | makeBaseModel ()
| Save a copy of model with certain state - normally without cuts.
void | deleteBaseModel ()
| Switch off base model.
ClpSimplex * | baseModel () const
| See if we have base model.
void | setToBaseModel (ClpSimplex *model=NULL)
| Reset to base model (just size and arrays needed) If model NULL use internal copy.
ClpSimplex & | operator= (const ClpSimplex &rhs)
| Assignment operator. This copies the data.
| ~ClpSimplex ()
| Destructor.
void | loadProblem (const ClpMatrixBase &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Loads a problem (the constraints on the rows are given by lower and upper bounds).
void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Default constructor.
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Just like the other loadProblem() method except that the matrix is given in a standard column major ordered format (without gaps).
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const int *length, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| This one is for after presolve to save memory.
int | loadProblem (CoinModel &modelObject, bool keepSolution=false)
| This loads a model from a coinModel object - returns number of errors.
int | readMps (const char *filename, bool keepNames=false, bool ignoreErrors=false)
| Read an mps file from the given filename.
int | readGMPL (const char *filename, const char *dataName, bool keepNames=false)
| Read GMPL files from the given filenames.
int | readLp (const char *filename, const double epsilon=1e-5)
| Read file in LP format from file with name filename.
void | borrowModel (ClpModel &otherModel)
| Borrow model.
void | borrowModel (ClpSimplex &otherModel)
| Default constructor.
void | passInEventHandler (const ClpEventHandler *eventHandler)
| Pass in Event handler (cloned and deleted at end).
void | getbackSolution (const ClpSimplex &smallModel, const int *whichRow, const int *whichColumn)
| Puts solution back into small model.
int | loadNonLinear (void *info, int &numberConstraints, ClpConstraint **&constraints)
| Load nonlinear part of problem from AMPL info Returns 0 if linear 1 if quadratic objective 2 if quadratic constraints 3 if nonlinear objective 4 if nonlinear constraints -1 on failure.
Functions most useful to user
int | initialSolve (ClpSolve &options)
| General solve algorithm which can do presolve.
int | initialSolve ()
| Default initial solve.
int | initialDualSolve ()
| Dual initial solve.
int | initialPrimalSolve ()
| Primal initial solve.
int | initialBarrierSolve ()
| Barrier initial solve.
int | initialBarrierNoCrossSolve ()
| Barrier initial solve, not to be followed by crossover.
int | dual (int ifValuesPass=0, int startFinishOptions=0)
| Dual algorithm - see ClpSimplexDual.hpp for method.
int | dualDebug (int ifValuesPass=0, int startFinishOptions=0)
| General solve algorithm which can do presolve.
int | primal (int ifValuesPass=0, int startFinishOptions=0)
| Primal algorithm - see ClpSimplexPrimal.hpp for method.
int | nonlinearSLP (int numberPasses, double deltaTolerance)
| Solves nonlinear problem using SLP - may be used as crash for other algorithms when number of iterations small.
int | nonlinearSLP (int numberConstraints, ClpConstraint **constraints, int numberPasses, double deltaTolerance)
| Solves problem with nonlinear constraints using SLP - may be used as crash for other algorithms when number of iterations small.
int | barrier (bool crossover=true)
| Solves using barrier (assumes you have good cholesky factor code).
int | reducedGradient (int phase=0)
| Solves non-linear using reduced gradient.
int | solve (CoinStructuredModel *model)
| Solve using structure of model and maybe in parallel.
int | loadProblem (CoinStructuredModel &modelObject, bool originalOrder=true, bool keepSolution=false)
| This loads a model from a CoinStructuredModel object - returns number of errors.
int | cleanup (int cleanupScaling)
| When scaling is on it is possible that the scaled problem is feasible but the unscaled is not.
int | dualRanging (int numberCheck, const int *which, double *costIncrease, int *sequenceIncrease, double *costDecrease, int *sequenceDecrease, double *valueIncrease=NULL, double *valueDecrease=NULL)
| Dual ranging.
int | primalRanging (int numberCheck, const int *which, double *valueIncrease, int *sequenceIncrease, double *valueDecrease, int *sequenceDecrease)
| Primal ranging.
int | modifyCoefficientsAndPivot (int number, const int *which, const CoinBigIndex *start, const int *row, const double *newCoefficient, const unsigned char *newStatus=NULL, const double *newLower=NULL, const double *newUpper=NULL, const double *newObjective=NULL)
| Modifies coefficients etc and if necessary pivots in and out.
int | outDuplicateRows (int numberLook, int *whichRows, bool noOverlaps=false, double tolerance=-1.0, double cleanUp=0.0)
| Take out duplicate rows (includes scaled rows and intersections).
double | moveTowardsPrimalFeasible ()
| Try simple crash like techniques to get closer to primal feasibility returns final sum of infeasibilities.
void | removeSuperBasicSlacks (int threshold=0)
| Try simple crash like techniques to remove super basic slacks but only if > threshold.
ClpSimplex * | miniPresolve (char *rowType, char *columnType, void **info)
| Mini presolve (faster) Char arrays must be numberRows and numberColumns long on entry second part must be filled in as follows - 0 - possible >0 - take out and do something (depending on value - TBD) -1 row/column can't vanish but can have entries removed/changed -2 don't touch at all on exit <=0 ones will be in presolved problem struct will be created and will be long enough (information on length etc in first entry) user must delete struct.
void | miniPostsolve (const ClpSimplex *presolvedModel, void *info)
| After mini presolve.
int | writeBasis (const char *filename, bool writeValues=false, int formatType=0) const
| Write the basis in MPS format to the specified file.
int | readBasis (const char *filename)
| Read a basis from the given filename, returns -1 on file error, 0 if no values, 1 if values.
CoinWarmStartBasis * | getBasis () const
| Returns a basis (to be deleted by user).
void | setFactorization (ClpFactorization &factorization)
| Passes in factorization.
ClpFactorization * | swapFactorization (ClpFactorization *factorization)
| General solve algorithm which can do presolve.
void | copyFactorization (ClpFactorization &factorization)
| Copies in factorization to existing one.
int | tightenPrimalBounds (double factor=0.0, int doTight=0, bool tightIntegers=false)
| Tightens primal bounds to make dual faster.
int | crash (double gap, int pivot)
| Crash - at present just aimed at dual, returns -2 if dual preferred and crash basis created -1 if dual preferred and all slack basis preferred 0 if basis going in was not all slack 1 if primal preferred and all slack basis preferred 2 if primal preferred and crash basis created.
void | setDualRowPivotAlgorithm (ClpDualRowPivot &choice)
| Sets row pivot choice algorithm in dual.
void | setPrimalColumnPivotAlgorithm (ClpPrimalColumnPivot &choice)
| Sets column pivot choice algorithm in primal.
int | strongBranching (int numberVariables, const int *variables, double *newLower, double *newUpper, double **outputSolution, int *outputStatus, int *outputIterations, bool stopOnFirstInfeasible=true, bool alwaysFinish=false, int startFinishOptions=0)
| For strong branching.
int | fathom (void *stuff)
| Fathom - 1 if solution.
int | fathomMany (void *stuff)
| Do up to N deep - returns -1 - no solution nNodes_ valid nodes >= if solution and that node gives solution ClpNode array is 2**N long.
double | doubleCheck ()
| Double checks OK.
int | startFastDual2 (ClpNodeStuff *stuff)
| Starts Fast dual2.
int | fastDual2 (ClpNodeStuff *stuff)
| Like Fast dual.
void | stopFastDual2 (ClpNodeStuff *stuff)
| Stops Fast dual2.
ClpSimplex * | fastCrunch (ClpNodeStuff *stuff, int mode)
| Deals with crunch aspects mode 0 - in 1 - out with solution 2 - out without solution returns small model or NULL.
Needed for functionality of OsiSimplexInterface
int | pivot ()
| Pivot in a variable and out a variable.
int | primalPivotResult ()
| Pivot in a variable and choose an outgoing one.
int | dualPivotResultPart1 ()
| Pivot out a variable and choose an incoing one.
int | pivotResultPart2 (int algorithm, int state)
| Do actual pivot state is 0 if need tableau column, 1 if in rowArray_[1].
int | startup (int ifValuesPass, int startFinishOptions=0)
| Common bits of coding for dual and primal.
void | finish (int startFinishOptions=0)
| Pivot in a variable and out a variable.
bool | statusOfProblem (bool initial=false)
| Factorizes and returns true if optimal.
void | defaultFactorizationFrequency ()
| If user left factorization frequency then compute.
void | copyEnabledStuff (const ClpSimplex *rhs)
| Copy across enabled stuff from one solver to another.
most useful gets and sets
bool | primalFeasible () const
| If problem is primal feasible.
bool | dualFeasible () const
| If problem is dual feasible.
ClpFactorization * | factorization () const
| factorization
bool | sparseFactorization () const
| Sparsity on or off.
void | setSparseFactorization (bool value)
| If problem is primal feasible.
int | factorizationFrequency () const
| Factorization frequency.
void | setFactorizationFrequency (int value)
| If problem is primal feasible.
double | dualBound () const
| Dual bound.
void | setDualBound (double value)
| If problem is primal feasible.
double | infeasibilityCost () const
| Infeasibility cost.
void | setInfeasibilityCost (double value)
| If problem is primal feasible.
int | perturbation () const
| Amount of print out: 0 - none 1 - just final 2 - just factorizations 3 - as 2 plus a bit more 4 - verbose above that 8,16,32 etc just for selective debug.
void | setPerturbation (int value)
| If problem is primal feasible.
int | algorithm () const
| Current (or last) algorithm.
void | setAlgorithm (int value)
| Set algorithm.
bool | isObjectiveLimitTestValid () const
| Return true if the objective limit test can be relied upon.
double | sumDualInfeasibilities () const
| Sum of dual infeasibilities.
void | setSumDualInfeasibilities (double value)
| If problem is primal feasible.
double | sumOfRelaxedDualInfeasibilities () const
| Sum of relaxed dual infeasibilities.
void | setSumOfRelaxedDualInfeasibilities (double value)
| If problem is primal feasible.
int | numberDualInfeasibilities () const
| Number of dual infeasibilities.
void | setNumberDualInfeasibilities (int value)
| If problem is primal feasible.
int | numberDualInfeasibilitiesWithoutFree () const
| Number of dual infeasibilities (without free).
double | sumPrimalInfeasibilities () const
| Sum of primal infeasibilities.
void | setSumPrimalInfeasibilities (double value)
| If problem is primal feasible.
double | sumOfRelaxedPrimalInfeasibilities () const
| Sum of relaxed primal infeasibilities.
void | setSumOfRelaxedPrimalInfeasibilities (double value)
| If problem is primal feasible.
int | numberPrimalInfeasibilities () const
| Number of primal infeasibilities.
void | setNumberPrimalInfeasibilities (int value)
| If problem is primal feasible.
int | saveModel (const char *fileName)
| Save model to file, returns 0 if success.
int | restoreModel (const char *fileName)
| Restore model from file, returns 0 if success, deletes current model.
void | checkSolution (int setToBounds=0)
| Just check solution (for external use) - sets sum of infeasibilities etc.
void | checkSolutionInternal ()
| Just check solution (for internal use) - sets sum of infeasibilities etc.
void | checkUnscaledSolution ()
| Check unscaled primal solution but allow for rounding error.
CoinIndexedVector * | rowArray (int index) const
| Useful row length arrays (0,1,2,3,4,5).
CoinIndexedVector * | columnArray (int index) const
| Useful column length arrays (0,1,2,3,4,5).
double | alphaAccuracy () const
| Initial value for alpha accuracy calculation (-1.0 off).
void | setAlphaAccuracy (double value)
| If problem is primal feasible.
void | setDisasterHandler (ClpDisasterHandler *handler)
| Objective value.
ClpDisasterHandler * | disasterHandler () const
| Get disaster handler.
double | largeValue () const
| Large bound value (for complementarity etc).
void | setLargeValue (double value)
| If problem is primal feasible.
double | largestPrimalError () const
| Largest error on Ax-b.
double | largestDualError () const
| Largest error on basic duals.
void | setLargestPrimalError (double value)
| Largest error on Ax-b.
void | setLargestDualError (double value)
| Largest error on basic duals.
double | zeroTolerance () const
| Get zero tolerance.
void | setZeroTolerance (double value)
| Set zero tolerance.
int * | pivotVariable () const
| Basic variables pivoting on which rows.
bool | automaticScaling () const
| If automatic scaling on.
void | setAutomaticScaling (bool onOff)
| If problem is primal feasible.
double | currentDualTolerance () const
| Current dual tolerance.
void | setCurrentDualTolerance (double value)
| If problem is primal feasible.
double | currentPrimalTolerance () const
| Current primal tolerance.
void | setCurrentPrimalTolerance (double value)
| If problem is primal feasible.
int | numberRefinements () const
| How many iterative refinements to do.
void | setNumberRefinements (int value)
| If problem is primal feasible.
double | alpha () const
| Alpha (pivot element) for use by classes e.g. steepestedge.
void | setAlpha (double value)
| If problem is primal feasible.
double | dualIn () const
| Reduced cost of last incoming for use by classes e.g. steepestedge.
void | setDualIn (double value)
| Set reduced cost of last incoming to force error.
int | pivotRow () const
| Pivot Row for use by classes e.g. steepestedge.
void | setPivotRow (int value)
| If problem is primal feasible.
double | valueIncomingDual () const
| value of incoming variable (in Dual)
public methods
double * | solutionRegion (int section) const
| Return row or column sections - not as much needed as it once was.
double * | djRegion (int section) const
| Return row or column sections - not as much needed as it once was.
double * | lowerRegion (int section) const
| Return row or column sections - not as much needed as it once was.
double * | upperRegion (int section) const
| Return row or column sections - not as much needed as it once was.
double * | costRegion (int section) const
| Return row or column sections - not as much needed as it once was.
double * | solutionRegion () const
| Return region as single array.
double * | djRegion () const
| Return row or column sections - not as much needed as it once was.
double * | lowerRegion () const
| Return row or column sections - not as much needed as it once was.
double * | upperRegion () const
| Return row or column sections - not as much needed as it once was.
double * | costRegion () const
| Return row or column sections - not as much needed as it once was.
Status | getStatus (int sequence) const
| Return row or column sections - not as much needed as it once was.
void | setStatus (int sequence, Status newstatus)
| Return row or column sections - not as much needed as it once was.
bool | startPermanentArrays ()
| Start or reset using maximumRows_ and Columns_ - true if change.
void | setInitialDenseFactorization (bool onOff)
| Normally the first factorization does sparse coding because the factorization could be singular.
bool | initialDenseFactorization () const
| Return row or column sections - not as much needed as it once was.
int | sequenceIn () const
| Return sequence In or Out.
int | sequenceOut () const
| Return row or column sections - not as much needed as it once was.
void | setSequenceIn (int sequence)
| Set sequenceIn or Out.
void | setSequenceOut (int sequence)
| Return row or column sections - not as much needed as it once was.
int | directionIn () const
| Return direction In or Out.
int | directionOut () const
| Return row or column sections - not as much needed as it once was.
void | setDirectionIn (int direction)
| Set directionIn or Out.
void | setDirectionOut (int direction)
| Return row or column sections - not as much needed as it once was.
double | valueOut () const
| Value of Out variable.
void | setValueOut (double value)
| Set value of out variable.
double | dualOut () const
| Dual value of Out variable.
void | setDualOut (double value)
| Set dual value of out variable.
void | setLowerOut (double value)
| Set lower of out variable.
void | setUpperOut (double value)
| Set upper of out variable.
void | setTheta (double value)
| Set theta of out variable.
int | isColumn (int sequence) const
| Returns 1 if sequence indicates column.
int | sequenceWithin (int sequence) const
| Returns sequence number within section.
double | solution (int sequence)
| Return row or column values.
double & | solutionAddress (int sequence)
| Return address of row or column values.
double | reducedCost (int sequence)
| Return row or column sections - not as much needed as it once was.
double & | reducedCostAddress (int sequence)
| Return row or column sections - not as much needed as it once was.
double | lower (int sequence)
| Return row or column sections - not as much needed as it once was.
double & | lowerAddress (int sequence)
| Return address of row or column lower bound.
double | upper (int sequence)
| Return row or column sections - not as much needed as it once was.
double & | upperAddress (int sequence)
| Return address of row or column upper bound.
double | cost (int sequence)
| Return row or column sections - not as much needed as it once was.
double & | costAddress (int sequence)
| Return address of row or column cost.
double | originalLower (int iSequence) const
| Return original lower bound.
double | originalUpper (int iSequence) const
| Return original lower bound.
double | theta () const
| Theta (pivot change).
double | bestPossibleImprovement () const
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).
ClpNonLinearCost * | nonLinearCost () const
| Return pointer to details of costs.
int | moreSpecialOptions () const
| Return more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - if factorization kept can still declare optimal at once 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible debug 32768 bit - do dual in netlibd 65536 (*3) initial stateDualColumn.
void | setMoreSpecialOptions (int value)
| Set more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows).
status methods
void | setFakeBound (int sequence, FakeBound fakeBound)
| To flag a variable (not inline to allow for column generation).
FakeBound | getFakeBound (int sequence) const
| To flag a variable (not inline to allow for column generation).
void | setRowStatus (int sequence, Status newstatus)
| To flag a variable (not inline to allow for column generation).
Status | getRowStatus (int sequence) const
| To flag a variable (not inline to allow for column generation).
void | setColumnStatus (int sequence, Status newstatus)
| To flag a variable (not inline to allow for column generation).
Status | getColumnStatus (int sequence) const
| To flag a variable (not inline to allow for column generation).
void | setPivoted (int sequence)
| To flag a variable (not inline to allow for column generation).
void | clearPivoted (int sequence)
| To flag a variable (not inline to allow for column generation).
bool | pivoted (int sequence) const
| To flag a variable (not inline to allow for column generation).
void | setFlagged (int sequence)
| To flag a variable (not inline to allow for column generation).
void | clearFlagged (int sequence)
| To flag a variable (not inline to allow for column generation).
bool | flagged (int sequence) const
| To flag a variable (not inline to allow for column generation).
void | setActive (int iRow)
| To say row active in primal pivot row choice.
void | clearActive (int iRow)
| To flag a variable (not inline to allow for column generation).
bool | active (int iRow) const
| To flag a variable (not inline to allow for column generation).
void | createStatus ()
| Set up status array (can be used by OsiClp).
void | allSlackBasis (bool resetSolution=false)
| Sets up all slack basis and resets solution to as it was after initial load or readMps.
int | lastBadIteration () const
| So we know when to be cautious.
void | setLastBadIteration (int value)
| Set so we know when to be cautious.
int | progressFlag () const
| Progress flag - at present 0 bit says artificials out.
ClpSimplexProgress * | progress ()
| For dealing with all issues of cycling etc.
int | forceFactorization () const
| Force re-factorization early value.
void | forceFactorization (int value)
| Force re-factorization early.
double | rawObjectiveValue () const
| Raw objective value (so always minimize in primal).
void | computeObjectiveValue (bool useWorkingSolution=false)
| Compute objective value from solution and put in objectiveValue_.
double | computeInternalObjectiveValue ()
| Compute minimization objective value from internal solution without perturbation.
double * | infeasibilityRay (bool fullRay=false) const
| Infeasibility/unbounded ray (NULL returned if none/wrong) Up to user to use delete [] on these arrays.
int | numberExtraRows () const
| Number of extra rows.
int | maximumBasic () const
| Maximum number of basic variables - can be more than number of rows if GUB.
int | baseIteration () const
| Iteration when we entered dual or primal.
void | generateCpp (FILE *fp, bool defaultFactor=false)
| Create C++ lines to get to current state.
ClpFactorization * | getEmptyFactorization ()
| Gets clean and emptyish factorization.
void | setEmptyFactorization ()
| May delete or may make clean and emptyish factorization.
void | moveInfo (const ClpSimplex &rhs, bool justStatus=false)
| Move status and solution across.
Basis handling
void | getBInvARow (int row, double *z, double *slack=NULL)
| Get a row of the tableau (slack part in slack if not NULL).
void | getBInvRow (int row, double *z)
| Get a row of the basis inverse.
void | getBInvACol (int col, double *vec)
| Get a column of the tableau.
void | getBInvCol (int col, double *vec)
| Get a column of the basis inverse.
void | getBasics (int *index)
| Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).
Changing bounds on variables and constraints
void | setObjectiveCoefficient (int elementIndex, double elementValue)
| Set an objective function coefficient.
void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
void | setColumnLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
void | setColumnUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
void | setColumnBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound.
void | setColumnSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
void | setColBounds (int elementIndex, double newlower, double newupper)
| Set a single column lower and upper bound.
void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously .
void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity.
void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity.
void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound.
void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously .
void | resize (int newNumberRows, int newNumberColumns)
| Resizes rim part of model.
## Protected Member Functions
protected methods
int | gutsOfSolution (double *givenDuals, const double *givenPrimals, bool valuesPass=false)
| May change basis and then returns number changed.
void | gutsOfDelete (int type)
| Does most of deletion (0 = all, 1 = most, 2 most + factorization).
void | gutsOfCopy (const ClpSimplex &rhs)
| Does most of copying.
bool | createRim (int what, bool makeRowCopy=false, int startFinishOptions=0)
| puts in format I like (rowLower,rowUpper) also see StandardMatrix 1 bit does rows (now and columns), (2 bit does column bounds), 4 bit does objective(s).
void | createRim1 (bool initial)
| Does rows and columns.
void | createRim4 (bool initial)
| Does objective.
void | createRim5 (bool initial)
| Does rows and columns and objective.
void | deleteRim (int getRidOfFactorizationData=2)
| releases above arrays and does solution scaling out.
bool | sanityCheck ()
| Sanity check on input rim data (after scaling) - returns true if okay.
## Friends
void | ClpSimplexUnitTest (const std::string &mpsDir)
| A function that tests the methods in the ClpSimplex class.
## data. Many arrays have a row part and a column part.
There is a single array with both - columns then rows and then normally two arrays pointing to rows and columns. The single array is the owner of memory
double | bestPossibleImprovement_
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).
double | zeroTolerance_
| Zero tolerance.
int | columnPrimalSequence_
| Sequence of worst (-1 if feasible).
int | rowPrimalSequence_
| Sequence of worst (-1 if feasible).
double | bestObjectiveValue_
| "Best" objective value
int | moreSpecialOptions_
| More special options - see set for details.
int | baseIteration_
| Iteration when we entered dual or primal.
double | primalToleranceToGetOptimal_
| Primal tolerance needed to make dual feasible (<largeTolerance).
double | largeValue_
| Large bound value (for complementarity etc).
double | largestPrimalError_
| Largest error on Ax-b.
double | largestDualError_
| Largest error on basic duals.
double | alphaAccuracy_
| For computing whether to re-factorize.
double | dualBound_
| Dual bound.
double | alpha_
| Alpha (pivot element).
double | theta_
| Theta (pivot change).
double | lowerIn_
| Lower Bound on In variable.
double | valueIn_
| Value of In variable.
double | upperIn_
| Upper Bound on In variable.
double | dualIn_
| Reduced cost of In variable.
double | lowerOut_
| Lower Bound on Out variable.
double | valueOut_
| Value of Out variable.
double | upperOut_
| Upper Bound on Out variable.
double | dualOut_
| Infeasibility (dual) or ? (primal) of Out variable.
double | dualTolerance_
| Current dual tolerance for algorithm.
double | primalTolerance_
| Current primal tolerance for algorithm.
double | sumDualInfeasibilities_
| Sum of dual infeasibilities.
double | sumPrimalInfeasibilities_
| Sum of primal infeasibilities.
double | infeasibilityCost_
| Weight assigned to being infeasible in primal.
double | sumOfRelaxedDualInfeasibilities_
| Sum of Dual infeasibilities using tolerance based on error in duals.
double | sumOfRelaxedPrimalInfeasibilities_
| Sum of Primal infeasibilities using tolerance based on error in primals.
double | acceptablePivot_
| Acceptable pivot value just after factorization.
double * | lower_
| Working copy of lower bounds (Owner of arrays below).
double * | rowLowerWork_
| Row lower bounds - working copy.
double * | columnLowerWork_
| Column lower bounds - working copy.
double * | upper_
| Working copy of upper bounds (Owner of arrays below).
double * | rowUpperWork_
| Row upper bounds - working copy.
double * | columnUpperWork_
| Column upper bounds - working copy.
double * | cost_
| Working copy of objective (Owner of arrays below).
double * | rowObjectiveWork_
| Row objective - working copy.
double * | objectiveWork_
| Column objective - working copy.
CoinIndexedVector * | rowArray_ [6]
| Useful row length arrays.
CoinIndexedVector * | columnArray_ [6]
| Useful column length arrays.
int | sequenceIn_
| Sequence of In variable.
int | directionIn_
| Direction of In, 1 going up, -1 going down, 0 not a clude.
int | sequenceOut_
| Sequence of Out variable.
int | directionOut_
| Direction of Out, 1 to upper bound, -1 to lower bound, 0 - superbasic.
int | pivotRow_
| Pivot Row.
int | lastGoodIteration_
| Last good iteration (immediately after a re-factorization).
double * | dj_
| Working copy of reduced costs (Owner of arrays below).
double * | rowReducedCost_
| Reduced costs of slacks not same as duals (or - duals).
double * | reducedCostWork_
| Possible scaled reduced costs.
double * | solution_
| Working copy of primal solution (Owner of arrays below).
double * | rowActivityWork_
| Row activities - working copy.
double * | columnActivityWork_
| Column activities - working copy.
int | numberDualInfeasibilities_
| Number of dual infeasibilities.
int | numberDualInfeasibilitiesWithoutFree_
| Number of dual infeasibilities (without free).
int | numberPrimalInfeasibilities_
| Number of primal infeasibilities.
int | numberRefinements_
| How many iterative refinements to do.
ClpDualRowPivot * | dualRowPivot_
| dual row pivot choice
ClpPrimalColumnPivot * | primalColumnPivot_
| primal column pivot choice
int * | pivotVariable_
| Basic variables pivoting on which rows.
ClpFactorization * | factorization_
| factorization
double * | savedSolution_
| Saved version of solution.
int | numberTimesOptimal_
| Number of times code has tentatively thought optimal.
ClpDisasterHandler * | disasterArea_
| Disaster handler.
int | changeMade_
| If change has been made (first attempt at stopping looping).
int | algorithm_
| Algorithm >0 == Primal, <0 == Dual.
int | forceFactorization_
| Now for some reliability aids This forces re-factorization early.
int | perturbation_
| Perturbation: -50 to +50 - perturb by this power of ten (-6 sounds good) 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100.
unsigned char * | saveStatus_
| Saved status regions.
ClpNonLinearCost * | nonLinearCost_
| Very wasteful way of dealing with infeasibilities in primal.
int | lastBadIteration_
| So we know when to be cautious.
int | lastFlaggedIteration_
| So we know when to open up again.
int | numberFake_
| Can be used for count of fake bounds (dual) or fake costs (primal).
int | numberChanged_
| Can be used for count of changed costs (dual) or changed bounds (primal).
int | progressFlag_
| Progress flag - at present 0 bit says artificials out, 1 free in.
int | firstFree_
| First free/super-basic variable (-1 if none).
int | numberExtraRows_
| Number of extra rows.
int | maximumBasic_
| Maximum number of basic variables - can be more than number of rows if GUB.
int | dontFactorizePivots_
| If may skip final factorize then allow up to this pivots (default 20).
double | incomingInfeasibility_
| For advanced use.
double | allowedInfeasibility_
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).
int | automaticScale_
| Automatic scaling of objective and rhs and bounds.
int | maximumPerturbationSize_
| Maximum perturbation array size (take out when code rewritten).
double * | perturbationArray_
| Perturbation array (maximumPerturbationSize_).
ClpSimplex * | baseModel_
| A copy of model with certain state - normally without cuts.
ClpSimplexProgress | progress_
| For dealing with all issues of cycling etc.
int | abcState_
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).
int | spareIntArray_ [4]
| Spare int array for passing information [0]!=0 switches on.
double | spareDoubleArray_ [4]
| Spare double array for passing information [0]!=0 switches on.
class | OsiClpSolverInterface
| Allow OsiClp certain perks.
## Functions less likely to be useful to casual user
int | getSolution (const double *rowActivities, const double *columnActivities)
| Given an existing factorization computes and checks primal and dual solutions.
int | getSolution ()
| Given an existing factorization computes and checks primal and dual solutions.
int | createPiecewiseLinearCosts (const int *starts, const double *lower, const double *gradient)
| Constructs a non linear cost from list of non-linearities (columns only) First lower of each column is taken as real lower Last lower is taken as real upper and cost ignored.
ClpDualRowPivot * | dualRowPivot () const
| dual row pivot choice
ClpPrimalColumnPivot * | primalColumnPivot () const
| primal column pivot choice
bool | goodAccuracy () const
| Returns true if model looks OK.
void | returnModel (ClpSimplex &otherModel)
| Return model - updates any scalars.
int | internalFactorize (int solveType)
| Factorizes using current basis.
ClpDataSave | saveData ()
| Save data.
void | restoreData (ClpDataSave saved)
| Restore data.
void | cleanStatus ()
| Clean up status.
int | factorize ()
| Factorizes using current basis. For external use.
void | computeDuals (double *givenDjs)
| Computes duals from scratch.
void | computePrimals (const double *rowActivities, const double *columnActivities)
| Computes primals from scratch.
void | add (double *array, int column, double multiplier) const
| Adds multiple of a column into an array.
void | unpack (CoinIndexedVector *rowArray) const
| Unpacks one column of the matrix into indexed array Uses sequenceIn_ Also applies scaling if needed.
void | unpack (CoinIndexedVector *rowArray, int sequence) const
| Unpacks one column of the matrix into indexed array Slack if sequence>= numberColumns Also applies scaling if needed.
void | unpackPacked (CoinIndexedVector *rowArray)
| Unpacks one column of the matrix into indexed array as packed vector Uses sequenceIn_ Also applies scaling if needed.
void | unpackPacked (CoinIndexedVector *rowArray, int sequence)
| Unpacks one column of the matrix into indexed array as packed vector Slack if sequence>= numberColumns Also applies scaling if needed.
void | setValuesPassAction (double incomingInfeasibility, double allowedInfeasibility)
| For advanced use.
int | cleanFactorization (int ifValuesPass)
| Get a clean factorization - i.e.
int | housekeeping (double objectiveChange)
| This does basis housekeeping and does values for in/out variables.
void | checkPrimalSolution (const double *rowActivities=NULL, const double *columnActivies=NULL)
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal).
void | checkDualSolution ()
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual).
void | checkBothSolutions ()
| This sets sum and number of infeasibilities (Dual and Primal).
double | scaleObjective (double value)
| If input negative scales objective so maximum <= -value and returns scale factor used.
int | solveDW (CoinStructuredModel *model)
| Solve using Dantzig-Wolfe decomposition and maybe in parallel.
int | solveBenders (CoinStructuredModel *model)
| Solve using Benders decomposition and maybe in parallel.

## Detailed Description

This solves LPs using the simplex method.

It inherits from ClpModel and all its arrays are created at algorithm time. Originally I tried to work with model arrays but for simplicity of coding I changed to single arrays with structural variables then row variables. Some coding is still based on old style and needs cleaning up.

For a description of algorithms:

for dual see ClpSimplexDual.hpp and at top of ClpSimplexDual.cpp for primal see ClpSimplexPrimal.hpp and at top of ClpSimplexPrimal.cpp

There is an algorithm data member. + for primal variations and - for dual variations

Definition at line 55 of file ClpSimplex.hpp.

## Member Enumeration Documentation

enum ClpSimplex::Status

enums for status of various sorts.

First 4 match CoinWarmStartBasis, isFixed means fixed at lower bound and out of basis

Enumerator:

  isFree |
  basic |
  atUpperBound |
  atLowerBound |
  superBasic |
  isFixed |

Reimplemented in AbcSimplex.

Definition at line 63 of file ClpSimplex.hpp.

enum ClpSimplex::FakeBound

Enumerator:

  noFake |
  lowerFake |
  upperFake |
  bothFake |

Reimplemented in AbcSimplex.

Definition at line 72 of file ClpSimplex.hpp.

## Constructor & Destructor Documentation

ClpSimplex::ClpSimplex | ( | bool | emptyMessages = `false` | ) |

Default constructor.

ClpSimplex::ClpSimplex | ( | const ClpSimplex & | rhs,
|  | int | scalingMode = `-1` |
| ) |  |  |

Copy constructor.

May scale depending on mode -1 leave mode as is 0 -off, 1 equilibrium, 2 geometric, 3, auto, 4 dynamic(later)

ClpSimplex::ClpSimplex | ( | const ClpModel & | rhs,
|  | int | scalingMode = `-1` |
| ) |  |  |

Copy constructor from model.

May scale depending on mode -1 leave mode as is 0 -off, 1 equilibrium, 2 geometric, 3, auto, 4 dynamic(later)

ClpSimplex::ClpSimplex | ( | const ClpModel * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false` |
| ) |  |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

ClpSimplex::ClpSimplex | ( | const ClpSimplex * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false` |
| ) |  |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

ClpSimplex::ClpSimplex | ( | ClpSimplex * | wholeModel,
|  | int | numberColumns,
|  | const int * | whichColumns |
| ) |  |  |

This constructor modifies original ClpSimplex and stores original stuff in created ClpSimplex.

It is only to be used in conjunction with originalModel

ClpSimplex::~ClpSimplex | ( |  | ) |

Destructor.

## Member Function Documentation

void ClpSimplex::originalModel | ( | ClpSimplex * | miniModel | ) |

This copies back stuff from miniModel and then deletes miniModel.

Only to be used with mini constructor

Reimplemented in AbcSimplex.

int ClpSimplex::abcState | ( |  | ) | const`[inline]`

Default constructor.

Definition at line 124 of file ClpSimplex.hpp.

void ClpSimplex::setAbcState | ( | int | state | ) | `[inline]`

Default constructor.

Definition at line 126 of file ClpSimplex.hpp.

void ClpSimplex::setPersistenceFlag | ( | int | value | ) |

Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.

void ClpSimplex::makeBaseModel | ( |  | ) |

Save a copy of model with certain state - normally without cuts.

Reimplemented in AbcSimplex.

void ClpSimplex::deleteBaseModel | ( |  | ) |

Switch off base model.

Reimplemented in AbcSimplex.

ClpSimplex* ClpSimplex::baseModel | ( |  | ) | const`[inline]`

See if we have base model.

Reimplemented in AbcSimplex.

Definition at line 149 of file ClpSimplex.hpp.

void ClpSimplex::setToBaseModel | ( | ClpSimplex * | model = `NULL` | ) |

Reset to base model (just size and arrays needed) If model NULL use internal copy.

Reimplemented in AbcSimplex.

ClpSimplex& ClpSimplex::operator= | ( | const ClpSimplex & | rhs | ) |

Assignment operator. This copies the data.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::loadProblem | ( | const ClpMatrixBase & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL` |
| ) |  |  |

Loads a problem (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Reimplemented from ClpModel.

void ClpSimplex::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL` |
| ) |  |  |

Default constructor.

Reimplemented from ClpModel.

void ClpSimplex::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL` |
| ) |  |  |

Just like the other loadProblem() method except that the matrix is given in a standard column major ordered format (without gaps).

Reimplemented from ClpModel.

void ClpSimplex::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const int * | length,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL` |
| ) |  |  |

This one is for after presolve to save memory.

Reimplemented from ClpModel.

int ClpSimplex::loadProblem | ( | CoinModel & | modelObject,
|  | bool | keepSolution = `false` |
| ) |  |  |

This loads a model from a coinModel object - returns number of errors.

If keepSolution true and size is same as current then keeps current status and solution

Reimplemented from ClpModel.

int ClpSimplex::readMps | ( | const char * | filename,
|  | bool | keepNames = `false`,
|  | bool | ignoreErrors = `false` |
| ) |  |  |

Read an mps file from the given filename.

Reimplemented from ClpModel.

int ClpSimplex::readGMPL | ( | const char * | filename,
|  | const char * | dataName,
|  | bool | keepNames = `false` |
| ) |  |  |

Read GMPL files from the given filenames.

Reimplemented from ClpModel.

int ClpSimplex::readLp | ( | const char * | filename,
|  | const double | epsilon = `1e-5` |
| ) |  |  |

Read file in LP format from file with name filename.

See class CoinLpIO for description of this format.

void ClpSimplex::borrowModel | ( | ClpModel & | otherModel | ) |

Borrow model.

This is so we dont have to copy large amounts of data around. It assumes a derived class wants to overwrite an empty model with a real one - while it does an algorithm. This is same as ClpModel one, but sets scaling on etc.

void ClpSimplex::borrowModel | ( | ClpSimplex & | otherModel | ) |

Default constructor.

Reimplemented from ClpModel.

void ClpSimplex::passInEventHandler | ( | const ClpEventHandler * | eventHandler | ) |

Pass in Event handler (cloned and deleted at end).

Reimplemented from ClpModel.

void ClpSimplex::getbackSolution | ( | const ClpSimplex & | smallModel,
|  | const int * | whichRow,
|  | const int * | whichColumn |
| ) |  |  |

Puts solution back into small model.

int ClpSimplex::loadNonLinear | ( | void * | info,
|  | int & | numberConstraints,
|  | ClpConstraint **& | constraints |
| ) |  |  |

Load nonlinear part of problem from AMPL info Returns 0 if linear 1 if quadratic objective 2 if quadratic constraints 3 if nonlinear objective 4 if nonlinear constraints -1 on failure.

int ClpSimplex::initialSolve | ( | ClpSolve & | options | ) |

General solve algorithm which can do presolve.

See ClpSolve.hpp for options

int ClpSimplex::initialSolve | ( |  | ) |

Default initial solve.

int ClpSimplex::initialDualSolve | ( |  | ) |

Dual initial solve.

int ClpSimplex::initialPrimalSolve | ( |  | ) |

Primal initial solve.

int ClpSimplex::initialBarrierSolve | ( |  | ) |

Barrier initial solve.

int ClpSimplex::initialBarrierNoCrossSolve | ( |  | ) |

Barrier initial solve, not to be followed by crossover.

int ClpSimplex::dual | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0` |
| ) |  |  |

Dual algorithm - see ClpSimplexDual.hpp for method.

ifValuesPass==2 just does values pass and then stops.

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

Reimplemented in ClpSimplexDual.

int ClpSimplex::dualDebug | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0` |
| ) |  |  |

General solve algorithm which can do presolve.

See ClpSolve.hpp for options

int ClpSimplex::primal | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0` |
| ) |  |  |

Primal algorithm - see ClpSimplexPrimal.hpp for method.

ifValuesPass==2 just does values pass and then stops.

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

Reimplemented in AbcSimplexPrimal, and ClpSimplexPrimal.

int ClpSimplex::nonlinearSLP | ( | int | numberPasses,
|  | double | deltaTolerance |
| ) |  |  |

Solves nonlinear problem using SLP - may be used as crash for other algorithms when number of iterations small.

Also exits if all problematical variables are changing less than deltaTolerance

int ClpSimplex::nonlinearSLP | ( | int | numberConstraints,
|  | ClpConstraint ** | constraints,
|  | int | numberPasses,
|  | double | deltaTolerance |
| ) |  |  |

Solves problem with nonlinear constraints using SLP - may be used as crash for other algorithms when number of iterations small.

Also exits if all problematical variables are changing less than deltaTolerance

int ClpSimplex::barrier | ( | bool | crossover = `true` | ) |

Solves using barrier (assumes you have good cholesky factor code).

Does crossover to simplex if asked

int ClpSimplex::reducedGradient | ( | int | phase = `0` | ) |

Solves non-linear using reduced gradient.

Phase = 0 get feasible, =1 use solution

int ClpSimplex::solve | ( | CoinStructuredModel * | model | ) |

Solve using structure of model and maybe in parallel.

int ClpSimplex::loadProblem | ( | CoinStructuredModel & | modelObject,
|  | bool | originalOrder = `true`,
|  | bool | keepSolution = `false` |
| ) |  |  |

This loads a model from a CoinStructuredModel object - returns number of errors.

If originalOrder then keep to order stored in blocks, otherwise first column/rows correspond to first block - etc. If keepSolution true and size is same as current then keeps current status and solution

int ClpSimplex::cleanup | ( | int | cleanupScaling | ) |

When scaling is on it is possible that the scaled problem is feasible but the unscaled is not.

Clp returns a secondary status code to that effect. This option allows for a cleanup. If you use it I would suggest 1. This only affects actions when scaled optimal 0 - no action 1 - clean up using dual if primal infeasibility 2 - clean up using dual if dual infeasibility 3 - clean up using dual if primal or dual infeasibility 11,12,13 - as 1,2,3 but use primal

return code as dual/primal

int ClpSimplex::dualRanging | ( | int | numberCheck,
|  | const int * | which,
|  | double * | costIncrease,
|  | int * | sequenceIncrease,
|  | double * | costDecrease,
|  | int * | sequenceDecrease,
|  | double * | valueIncrease = `NULL`,
|  | double * | valueDecrease = `NULL` |
| ) |  |  |

Dual ranging.

This computes increase/decrease in cost for each given variable and corresponding sequence numbers which would change basis. Sequence numbers are 0..numberColumns and numberColumns.. for artificials/slacks. For non-basic variables the information is trivial to compute and the change in cost is just minus the reduced cost and the sequence number will be that of the non-basic variables. For basic variables a ratio test is between the reduced costs for non-basic variables and the row of the tableau corresponding to the basic variable. The increase/decrease value is always >= 0.0

Up to user to provide correct length arrays where each array is of length numberCheck. which contains list of variables for which information is desired. All other arrays will be filled in by function. If fifth entry in which is variable 7 then fifth entry in output arrays will be information for variable 7.

If valueIncrease/Decrease not NULL (both must be NULL or both non NULL) then these are filled with the value of variable if such a change in cost were made (the existing bounds are ignored)

Returns non-zero if infeasible unbounded etc

Reimplemented in ClpSimplexOther.

int ClpSimplex::primalRanging | ( | int | numberCheck,
|  | const int * | which,
|  | double * | valueIncrease,
|  | int * | sequenceIncrease,
|  | double * | valueDecrease,
|  | int * | sequenceDecrease |
| ) |  |  |

Primal ranging.

This computes increase/decrease in value for each given variable and corresponding sequence numbers which would change basis. Sequence numbers are 0..numberColumns and numberColumns.. for artificials/slacks. This should only be used for non-basic variabls as otherwise information is pretty useless For basic variables the sequence number will be that of the basic variables.

Up to user to provide correct length arrays where each array is of length numberCheck. which contains list of variables for which information is desired. All other arrays will be filled in by function. If fifth entry in which is variable 7 then fifth entry in output arrays will be information for variable 7.

Returns non-zero if infeasible unbounded etc

Reimplemented in ClpSimplexOther.

int ClpSimplex::modifyCoefficientsAndPivot | ( | int | number,
|  | const int * | which,
|  | const CoinBigIndex * | start,
|  | const int * | row,
|  | const double * | newCoefficient,
|  | const unsigned char * | newStatus = `NULL`,
|  | const double * | newLower = `NULL`,
|  | const double * | newUpper = `NULL`,
|  | const double * | newObjective = `NULL` |
| ) |  |  |

Modifies coefficients etc and if necessary pivots in and out.

All at same status will be done (basis may go singular). User can tell which others have been done (i.e. if status matches). If called from outside will change status and return 0. If called from event handler returns non-zero if user has to take action. indices>=numberColumns are slacks (obviously no coefficients) status array is (char) Status enum

int ClpSimplex::outDuplicateRows | ( | int | numberLook,
|  | int * | whichRows,
|  | bool | noOverlaps = `false`,
|  | double | tolerance = `-1.0`,
|  | double | cleanUp = `0.0` |
| ) |  |  |

Take out duplicate rows (includes scaled rows and intersections).

On exit whichRows has rows to delete - return code is number can be deleted or -1 if would be infeasible. If tolerance is -1.0 use primalTolerance for equality rows and infeasibility If cleanUp not zero then spend more time trying to leave more stable row and make row bounds exact multiple of cleanUp if close enough

double ClpSimplex::moveTowardsPrimalFeasible | ( |  | ) |

Try simple crash like techniques to get closer to primal feasibility returns final sum of infeasibilities.

void ClpSimplex::removeSuperBasicSlacks | ( | int | threshold = `0` | ) |

Try simple crash like techniques to remove super basic slacks but only if > threshold.

ClpSimplex* ClpSimplex::miniPresolve | ( | char * | rowType,
|  | char * | columnType,
|  | void ** | info |
| ) |  |  |

Mini presolve (faster) Char arrays must be numberRows and numberColumns long on entry second part must be filled in as follows - 0 - possible >0 - take out and do something (depending on value - TBD) -1 row/column can't vanish but can have entries removed/changed -2 don't touch at all on exit <=0 ones will be in presolved problem struct will be created and will be long enough (information on length etc in first entry) user must delete struct.

void ClpSimplex::miniPostsolve | ( | const ClpSimplex * | presolvedModel,
|  | void * | info |
| ) |  |  |

After mini presolve.

int ClpSimplex::writeBasis | ( | const char * | filename,
|  | bool | writeValues = `false`,
|  | int | formatType = `0` |
| ) |  |  | const

Write the basis in MPS format to the specified file.

If writeValues true writes values of structurals (and adds VALUES to end of NAME card)

Row and column names may be null. formatType is

- 0 - normal
- 1 - extra accuracy
- 2 - IEEE hex (later)

Returns non-zero on I/O error

Reimplemented in ClpSimplexOther.

int ClpSimplex::readBasis | ( | const char * | filename | ) |

Read a basis from the given filename, returns -1 on file error, 0 if no values, 1 if values.

Reimplemented in ClpSimplexOther.

CoinWarmStartBasis* ClpSimplex::getBasis | ( |  | ) | const

Returns a basis (to be deleted by user).

Reimplemented in AbcSimplex.

void ClpSimplex::setFactorization | ( | ClpFactorization & | factorization | ) |

Passes in factorization.

ClpFactorization* ClpSimplex::swapFactorization | ( | ClpFactorization * | factorization | ) |

General solve algorithm which can do presolve.

See ClpSolve.hpp for options

void ClpSimplex::copyFactorization | ( | ClpFactorization & | factorization | ) |

Copies in factorization to existing one.

int ClpSimplex::tightenPrimalBounds | ( | double | factor = `0.0`,
|  | int | doTight = `0`,
|  | bool | tightIntegers = `false` |
| ) |  |  |

Tightens primal bounds to make dual faster.

Unless fixed or doTight>10, bounds are slightly looser than they could be. This is to make dual go faster and is probably not needed with a presolve. Returns non-zero if problem infeasible.

Fudge for branch and bound - put bounds on columns of factor * largest value (at continuous) - should improve stability in branch and bound on infeasible branches (0.0 is off)

int ClpSimplex::crash | ( | double | gap,
|  | int | pivot |
| ) |  |  |

Crash - at present just aimed at dual, returns -2 if dual preferred and crash basis created -1 if dual preferred and all slack basis preferred 0 if basis going in was not all slack 1 if primal preferred and all slack basis preferred 2 if primal preferred and crash basis created.

if gap between bounds <="gap" variables can be flipped ( If pivot -1 then can be made super basic!)

If "pivot" is -1 No pivoting - always primal 0 No pivoting (so will just be choice of algorithm) 1 Simple pivoting e.g. gub 2 Mini iterations

void ClpSimplex::setDualRowPivotAlgorithm | ( | ClpDualRowPivot & | choice | ) |

Sets row pivot choice algorithm in dual.

void ClpSimplex::setPrimalColumnPivotAlgorithm | ( | ClpPrimalColumnPivot & | choice | ) |

Sets column pivot choice algorithm in primal.

int ClpSimplex::strongBranching | ( | int | numberVariables,
|  | const int * | variables,
|  | double * | newLower,
|  | double * | newUpper,
|  | double ** | outputSolution,
|  | int * | outputStatus,
|  | int * | outputIterations,
|  | bool | stopOnFirstInfeasible = `true`,
|  | bool | alwaysFinish = `false`,
|  | int | startFinishOptions = `0` |
| ) |  |  |

For strong branching.

On input lower and upper are new bounds while on output they are change in objective function values (>1.0e50 infeasible). Return code is 0 if nothing interesting, -1 if infeasible both ways and +1 if infeasible one way (check values to see which one(s)) Solutions are filled in as well - even down, odd up - also status and number of iterations

Reimplemented in AbcSimplexDual, and ClpSimplexDual.

int ClpSimplex::fathom | ( | void * | stuff | ) |

Fathom - 1 if solution.

int ClpSimplex::fathomMany | ( | void * | stuff | ) |

Do up to N deep - returns -1 - no solution nNodes_ valid nodes >= if solution and that node gives solution ClpNode array is 2**N long.

Values for N and array are in stuff (nNodes_ also in stuff)

double ClpSimplex::doubleCheck | ( |  | ) |

Double checks OK.

int ClpSimplex::startFastDual2 | ( | ClpNodeStuff * | stuff | ) |

Starts Fast dual2.

int ClpSimplex::fastDual2 | ( | ClpNodeStuff * | stuff | ) |

Like Fast dual.

void ClpSimplex::stopFastDual2 | ( | ClpNodeStuff * | stuff | ) |

Stops Fast dual2.

ClpSimplex* ClpSimplex::fastCrunch | ( | ClpNodeStuff * | stuff,
|  | int | mode |
| ) |  |  |

Deals with crunch aspects mode 0 - in 1 - out with solution 2 - out without solution returns small model or NULL.

int ClpSimplex::pivot | ( |  | ) |

Pivot in a variable and out a variable.

Returns 0 if okay, 1 if inaccuracy forced re-factorization, -1 if would be singular. Also updates primal/dual infeasibilities. Assumes sequenceIn_ and pivotRow_ set and also directionIn and Out.

int ClpSimplex::primalPivotResult | ( |  | ) |

Pivot in a variable and choose an outgoing one.

Assumes primal feasible - will not go through a bound. Returns step length in theta Returns ray in ray_ (or NULL if no pivot) Return codes as before but -1 means no acceptable pivot

int ClpSimplex::dualPivotResultPart1 | ( |  | ) |

Pivot out a variable and choose an incoing one.

Assumes dual feasible - will not go through a reduced cost. Returns step length in theta Return codes as before but -1 means no acceptable pivot

int ClpSimplex::pivotResultPart2 | ( | int | algorithm,
|  | int | state |
| ) |  |  |

Do actual pivot state is 0 if need tableau column, 1 if in rowArray_[1].

int ClpSimplex::startup | ( | int | ifValuesPass,
|  | int | startFinishOptions = `0` |
| ) |  |  |

Common bits of coding for dual and primal.

Return 0 if okay, 1 if bad matrix, 2 if very bad factorization

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

void ClpSimplex::finish | ( | int | startFinishOptions = `0` | ) |

Pivot in a variable and out a variable.

Returns 0 if okay, 1 if inaccuracy forced re-factorization, -1 if would be singular. Also updates primal/dual infeasibilities. Assumes sequenceIn_ and pivotRow_ set and also directionIn and Out.

bool ClpSimplex::statusOfProblem | ( | bool | initial = `false` | ) |

Factorizes and returns true if optimal.

Used by user

void ClpSimplex::defaultFactorizationFrequency | ( |  | ) |

If user left factorization frequency then compute.

Reimplemented in AbcSimplex.

void ClpSimplex::copyEnabledStuff | ( | const ClpSimplex * | rhs | ) |

Copy across enabled stuff from one solver to another.

bool ClpSimplex::primalFeasible | ( |  | ) | const`[inline]`

If problem is primal feasible.

Definition at line 574 of file ClpSimplex.hpp.

bool ClpSimplex::dualFeasible | ( |  | ) | const`[inline]`

If problem is dual feasible.

Definition at line 578 of file ClpSimplex.hpp.

ClpFactorization* ClpSimplex::factorization | ( |  | ) | const`[inline]`

factorization

Reimplemented in AbcSimplex.

Definition at line 582 of file ClpSimplex.hpp.

bool ClpSimplex::sparseFactorization | ( |  | ) | const

Sparsity on or off.

void ClpSimplex::setSparseFactorization | ( | bool | value | ) |

If problem is primal feasible.

int ClpSimplex::factorizationFrequency | ( |  | ) | const

Factorization frequency.

Reimplemented in AbcSimplex.

void ClpSimplex::setFactorizationFrequency | ( | int | value | ) |

If problem is primal feasible.

Reimplemented in AbcSimplex.

double ClpSimplex::dualBound | ( |  | ) | const`[inline]`

Dual bound.

Definition at line 592 of file ClpSimplex.hpp.

void ClpSimplex::setDualBound | ( | double | value | ) |

If problem is primal feasible.

double ClpSimplex::infeasibilityCost | ( |  | ) | const`[inline]`

Infeasibility cost.

Definition at line 597 of file ClpSimplex.hpp.

void ClpSimplex::setInfeasibilityCost | ( | double | value | ) |

If problem is primal feasible.

int ClpSimplex::perturbation | ( |  | ) | const`[inline]`

Amount of print out: 0 - none 1 - just final 2 - just factorizations 3 - as 2 plus a bit more 4 - verbose above that 8,16,32 etc just for selective debug.

Perturbation: 50 - switch on perturbation 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100 others are for playing

Definition at line 617 of file ClpSimplex.hpp.

void ClpSimplex::setPerturbation | ( | int | value | ) |

If problem is primal feasible.

int ClpSimplex::algorithm | ( |  | ) | const`[inline]`

Current (or last) algorithm.

Definition at line 622 of file ClpSimplex.hpp.

void ClpSimplex::setAlgorithm | ( | int | value | ) | `[inline]`

Set algorithm.

Definition at line 626 of file ClpSimplex.hpp.

bool ClpSimplex::isObjectiveLimitTestValid | ( |  | ) | const

Return true if the objective limit test can be relied upon.

Reimplemented in AbcSimplex.

double ClpSimplex::sumDualInfeasibilities | ( |  | ) | const`[inline]`

Sum of dual infeasibilities.

Definition at line 632 of file ClpSimplex.hpp.

void ClpSimplex::setSumDualInfeasibilities | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 635 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedDualInfeasibilities | ( |  | ) | const`[inline]`

Sum of relaxed dual infeasibilities.

Definition at line 639 of file ClpSimplex.hpp.

void ClpSimplex::setSumOfRelaxedDualInfeasibilities | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 642 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilities | ( |  | ) | const`[inline]`

Number of dual infeasibilities.

Definition at line 646 of file ClpSimplex.hpp.

void ClpSimplex::setNumberDualInfeasibilities | ( | int | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 649 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilitiesWithoutFree | ( |  | ) | const`[inline]`

Number of dual infeasibilities (without free).

Definition at line 653 of file ClpSimplex.hpp.

double ClpSimplex::sumPrimalInfeasibilities | ( |  | ) | const`[inline]`

Sum of primal infeasibilities.

Definition at line 657 of file ClpSimplex.hpp.

void ClpSimplex::setSumPrimalInfeasibilities | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 660 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedPrimalInfeasibilities | ( |  | ) | const`[inline]`

Sum of relaxed primal infeasibilities.

Definition at line 664 of file ClpSimplex.hpp.

void ClpSimplex::setSumOfRelaxedPrimalInfeasibilities | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 667 of file ClpSimplex.hpp.

int ClpSimplex::numberPrimalInfeasibilities | ( |  | ) | const`[inline]`

Number of primal infeasibilities.

Definition at line 671 of file ClpSimplex.hpp.

void ClpSimplex::setNumberPrimalInfeasibilities | ( | int | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 674 of file ClpSimplex.hpp.

int ClpSimplex::saveModel | ( | const char * | fileName | ) |

Save model to file, returns 0 if success.

This is designed for use outside algorithms so does not save iterating arrays etc. It does not save any messaging information. Does not save scaling values. It does not know about all types of virtual functions.

int ClpSimplex::restoreModel | ( | const char * | fileName | ) |

Restore model from file, returns 0 if success, deletes current model.

void ClpSimplex::checkSolution | ( | int | setToBounds = `0` | ) |

Just check solution (for external use) - sets sum of infeasibilities etc.

If setToBounds 0 then primal column values not changed and used to compute primal row activity values. If 1 or 2 then status used - so all nonbasic variables set to indicated bound and if any values changed (or ==2) basic values re-computed.

void ClpSimplex::checkSolutionInternal | ( |  | ) |

Just check solution (for internal use) - sets sum of infeasibilities etc.

void ClpSimplex::checkUnscaledSolution | ( |  | ) |

Check unscaled primal solution but allow for rounding error.

CoinIndexedVector* ClpSimplex::rowArray | ( | int | index | ) | const`[inline]`

Useful row length arrays (0,1,2,3,4,5).

Definition at line 702 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::columnArray | ( | int | index | ) | const`[inline]`

Useful column length arrays (0,1,2,3,4,5).

Definition at line 706 of file ClpSimplex.hpp.

int ClpSimplex::getSolution | ( | const double * | rowActivities,
|  | const double * | columnActivities |
| ) |  |  |

Given an existing factorization computes and checks primal and dual solutions.

Uses input arrays for variables at bounds. Returns feasibility states

int ClpSimplex::getSolution | ( |  | ) |

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

Reimplemented in AbcSimplex.

int ClpSimplex::createPiecewiseLinearCosts | ( | const int * | starts,
|  | const double * | lower,
|  | const double * | gradient |
| ) |  |  |

Constructs a non linear cost from list of non-linearities (columns only) First lower of each column is taken as real lower Last lower is taken as real upper and cost ignored.

Returns nonzero if bad data e.g. lowers not monotonic

ClpDualRowPivot* ClpSimplex::dualRowPivot | ( |  | ) | const`[inline]`

dual row pivot choice

Reimplemented in AbcSimplex.

Definition at line 732 of file ClpSimplex.hpp.

ClpPrimalColumnPivot* ClpSimplex::primalColumnPivot | ( |  | ) | const`[inline]`

primal column pivot choice

Reimplemented in AbcSimplex.

Definition at line 736 of file ClpSimplex.hpp.

bool ClpSimplex::goodAccuracy | ( |  | ) | const`[inline]`

Returns true if model looks OK.

Definition at line 740 of file ClpSimplex.hpp.

void ClpSimplex::returnModel | ( | ClpSimplex & | otherModel | ) |

Return model - updates any scalars.

Reimplemented from ClpModel.

int ClpSimplex::internalFactorize | ( | int | solveType | ) |

Factorizes using current basis.

solveType - 1 iterating, 0 initial, -1 external If 10 added then in primal values pass Return codes are as from ClpFactorization unless initial factorization when total number of singularities is returned. Special case is numberRows_+1 -> all slack basis.

Reimplemented in AbcSimplex.

ClpDataSave ClpSimplex::saveData | ( |  | ) |

Save data.

Reimplemented in AbcSimplex.

void ClpSimplex::restoreData | ( | ClpDataSave | saved | ) |

Restore data.

Reimplemented in AbcSimplex.

void ClpSimplex::cleanStatus | ( |  | ) |

Clean up status.

Reimplemented in AbcSimplex.

int ClpSimplex::factorize | ( |  | ) |

Factorizes using current basis. For external use.

void ClpSimplex::computeDuals | ( | double * | givenDjs | ) |

Computes duals from scratch.

If givenDjs then allows for nonzero basic djs

void ClpSimplex::computePrimals | ( | const double * | rowActivities,
|  | const double * | columnActivities |
| ) |  |  |

Computes primals from scratch.

void ClpSimplex::add | ( | double * | array,
|  | int | column,
|  | double | multiplier |
| ) |  |  | const

Adds multiple of a column into an array.

void ClpSimplex::unpack | ( | CoinIndexedVector * | rowArray | ) | const

Unpacks one column of the matrix into indexed array Uses sequenceIn_ Also applies scaling if needed.

void ClpSimplex::unpack | ( | CoinIndexedVector * | rowArray,
|  | int | sequence |
| ) |  |  | const

Unpacks one column of the matrix into indexed array Slack if sequence>= numberColumns Also applies scaling if needed.

void ClpSimplex::unpackPacked | ( | CoinIndexedVector * | rowArray | ) |

Unpacks one column of the matrix into indexed array as packed vector Uses sequenceIn_ Also applies scaling if needed.

void ClpSimplex::unpackPacked | ( | CoinIndexedVector * | rowArray,
|  | int | sequence |
| ) |  |  |

Unpacks one column of the matrix into indexed array as packed vector Slack if sequence>= numberColumns Also applies scaling if needed.

int ClpSimplex::housekeeping | ( | double | objectiveChange | ) | `[protected]`

This does basis housekeeping and does values for in/out variables.

Can also decide to re-factorize

void ClpSimplex::checkPrimalSolution | ( | const double * | rowActivities = `NULL`,
|  | const double * | columnActivies = `NULL` |
| ) |  |  | `[protected]`

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal).

void ClpSimplex::checkDualSolution | ( |  | ) | `[protected]`

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual).

Reimplemented in AbcSimplex.

void ClpSimplex::checkBothSolutions | ( |  | ) | `[protected]`

This sets sum and number of infeasibilities (Dual and Primal).

Reimplemented in AbcSimplex.

double ClpSimplex::scaleObjective | ( | double | value | ) | `[protected]`

If input negative scales objective so maximum <= -value and returns scale factor used.

If positive unscales and also redoes dual stuff

int ClpSimplex::solveDW | ( | CoinStructuredModel * | model | ) | `[protected]`

Solve using Dantzig-Wolfe decomposition and maybe in parallel.

int ClpSimplex::solveBenders | ( | CoinStructuredModel * | model | ) | `[protected]`

Solve using Benders decomposition and maybe in parallel.

void ClpSimplex::setValuesPassAction | ( | double | incomingInfeasibility,
|  | double | allowedInfeasibility |
| ) |  |  |

For advanced use.

When doing iterative solves things can get nasty so on values pass if incoming solution has largest infeasibility < incomingInfeasibility throw out variables from basis until largest infeasibility < allowedInfeasibility or incoming largest infeasibility. If allowedInfeasibility>= incomingInfeasibility this is always possible altough you may end up with an all slack basis.

Defaults are 1.0,10.0

Reimplemented in AbcSimplex.

int ClpSimplex::cleanFactorization | ( | int | ifValuesPass | ) |

Get a clean factorization - i.e.

throw out singularities may do more later

Reimplemented in AbcSimplex.

double ClpSimplex::alphaAccuracy | ( |  | ) | const`[inline]`

Initial value for alpha accuracy calculation (-1.0 off).

Definition at line 843 of file ClpSimplex.hpp.

void ClpSimplex::setAlphaAccuracy | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 846 of file ClpSimplex.hpp.

void ClpSimplex::setDisasterHandler | ( | ClpDisasterHandler * | handler | ) | `[inline]`

Objective value.

Set disaster handler

Definition at line 855 of file ClpSimplex.hpp.

ClpDisasterHandler* ClpSimplex::disasterHandler | ( |  | ) | const`[inline]`

Get disaster handler.

Definition at line 859 of file ClpSimplex.hpp.

double ClpSimplex::largeValue | ( |  | ) | const`[inline]`

Large bound value (for complementarity etc).

Definition at line 863 of file ClpSimplex.hpp.

void ClpSimplex::setLargeValue | ( | double | value | ) |

If problem is primal feasible.

double ClpSimplex::largestPrimalError | ( |  | ) | const`[inline]`

Largest error on Ax-b.

Definition at line 868 of file ClpSimplex.hpp.

double ClpSimplex::largestDualError | ( |  | ) | const`[inline]`

Largest error on basic duals.

Definition at line 872 of file ClpSimplex.hpp.

void ClpSimplex::setLargestPrimalError | ( | double | value | ) | `[inline]`

Largest error on Ax-b.

Definition at line 876 of file ClpSimplex.hpp.

void ClpSimplex::setLargestDualError | ( | double | value | ) | `[inline]`

Largest error on basic duals.

Definition at line 880 of file ClpSimplex.hpp.

double ClpSimplex::zeroTolerance | ( |  | ) | const`[inline]`

Get zero tolerance.

Definition at line 884 of file ClpSimplex.hpp.

void ClpSimplex::setZeroTolerance | ( | double | value | ) | `[inline]`

Set zero tolerance.

Definition at line 888 of file ClpSimplex.hpp.

int* ClpSimplex::pivotVariable | ( |  | ) | const`[inline]`

Basic variables pivoting on which rows.

Reimplemented in AbcSimplex.

Definition at line 892 of file ClpSimplex.hpp.

bool ClpSimplex::automaticScaling | ( |  | ) | const`[inline]`

If automatic scaling on.

Definition at line 896 of file ClpSimplex.hpp.

void ClpSimplex::setAutomaticScaling | ( | bool | onOff | ) | `[inline]`

If problem is primal feasible.

Definition at line 899 of file ClpSimplex.hpp.

double ClpSimplex::currentDualTolerance | ( |  | ) | const`[inline]`

Current dual tolerance.

Reimplemented in AbcSimplex.

Definition at line 903 of file ClpSimplex.hpp.

void ClpSimplex::setCurrentDualTolerance | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Reimplemented in AbcSimplex.

Definition at line 906 of file ClpSimplex.hpp.

double ClpSimplex::currentPrimalTolerance | ( |  | ) | const`[inline]`

Current primal tolerance.

Definition at line 910 of file ClpSimplex.hpp.

void ClpSimplex::setCurrentPrimalTolerance | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 913 of file ClpSimplex.hpp.

int ClpSimplex::numberRefinements | ( |  | ) | const`[inline]`

How many iterative refinements to do.

Definition at line 917 of file ClpSimplex.hpp.

void ClpSimplex::setNumberRefinements | ( | int | value | ) |

If problem is primal feasible.

double ClpSimplex::alpha | ( |  | ) | const`[inline]`

Alpha (pivot element) for use by classes e.g. steepestedge.

Definition at line 922 of file ClpSimplex.hpp.

void ClpSimplex::setAlpha | ( | double | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 925 of file ClpSimplex.hpp.

double ClpSimplex::dualIn | ( |  | ) | const`[inline]`

Reduced cost of last incoming for use by classes e.g. steepestedge.

Definition at line 929 of file ClpSimplex.hpp.

void ClpSimplex::setDualIn | ( | double | value | ) | `[inline]`

Set reduced cost of last incoming to force error.

Definition at line 933 of file ClpSimplex.hpp.

int ClpSimplex::pivotRow | ( |  | ) | const`[inline]`

Pivot Row for use by classes e.g. steepestedge.

Definition at line 937 of file ClpSimplex.hpp.

void ClpSimplex::setPivotRow | ( | int | value | ) | `[inline]`

If problem is primal feasible.

Definition at line 940 of file ClpSimplex.hpp.

double ClpSimplex::valueIncomingDual | ( |  | ) | const

value of incoming variable (in Dual)

Reimplemented in AbcSimplex.

int ClpSimplex::gutsOfSolution | ( | double * | givenDuals,
|  | const double * | givenPrimals,
|  | bool | valuesPass = `false` |
| ) |  |  | `[protected]`

May change basis and then returns number changed.

Computation of solutions may be overriden by given pi and solution

Reimplemented in AbcSimplex.

void ClpSimplex::gutsOfDelete | ( | int | type | ) | `[protected]`

Does most of deletion (0 = all, 1 = most, 2 most + factorization).

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::gutsOfCopy | ( | const ClpSimplex & | rhs | ) | `[protected]`

Does most of copying.

Reimplemented in AbcSimplex.

bool ClpSimplex::createRim | ( | int | what,
|  | bool | makeRowCopy = `false`,
|  | int | startFinishOptions = `0` |
| ) |  |  | `[protected]`

puts in format I like (rowLower,rowUpper) also see StandardMatrix 1 bit does rows (now and columns), (2 bit does column bounds), 4 bit does objective(s).

8 bit does solution scaling in 16 bit does rowArray and columnArray indexed vectors and makes row copy if wanted, also sets columnStart_ etc Also creates scaling arrays if needed. It does scaling if needed. 16 also moves solutions etc in to work arrays On 16 returns false if problem "bad" i.e. matrix or bounds bad If startFinishOptions is -1 then called by user in getSolution so do arrays but keep pivotVariable_

void ClpSimplex::createRim1 | ( | bool | initial | ) | `[protected]`

Does rows and columns.

void ClpSimplex::createRim4 | ( | bool | initial | ) | `[protected]`

Does objective.

void ClpSimplex::createRim5 | ( | bool | initial | ) | `[protected]`

Does rows and columns and objective.

void ClpSimplex::deleteRim | ( | int | getRidOfFactorizationData = `2` | ) | `[protected]`

releases above arrays and does solution scaling out.

May also get rid of factorization data - 0 get rid of nothing, 1 get rid of arrays, 2 also factorization

bool ClpSimplex::sanityCheck | ( |  | ) | `[protected]`

Sanity check on input rim data (after scaling) - returns true if okay.

double* ClpSimplex::solutionRegion | ( | int | section | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 993 of file ClpSimplex.hpp.

double* ClpSimplex::djRegion | ( | int | section | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 997 of file ClpSimplex.hpp.

double* ClpSimplex::lowerRegion | ( | int | section | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1001 of file ClpSimplex.hpp.

double* ClpSimplex::upperRegion | ( | int | section | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1005 of file ClpSimplex.hpp.

double* ClpSimplex::costRegion | ( | int | section | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1009 of file ClpSimplex.hpp.

double* ClpSimplex::solutionRegion | ( |  | ) | const`[inline]`

Return region as single array.

Reimplemented in AbcSimplex.

Definition at line 1014 of file ClpSimplex.hpp.

double* ClpSimplex::djRegion | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1017 of file ClpSimplex.hpp.

double* ClpSimplex::lowerRegion | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1020 of file ClpSimplex.hpp.

double* ClpSimplex::upperRegion | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1023 of file ClpSimplex.hpp.

double* ClpSimplex::costRegion | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1026 of file ClpSimplex.hpp.

Status ClpSimplex::getStatus | ( | int | sequence | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Definition at line 1029 of file ClpSimplex.hpp.

void ClpSimplex::setStatus | ( | int | sequence,
|  | Status | newstatus |
| ) |  |  | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Definition at line 1032 of file ClpSimplex.hpp.

bool ClpSimplex::startPermanentArrays | ( |  | ) |

Start or reset using maximumRows_ and Columns_ - true if change.

Reimplemented from ClpModel.

void ClpSimplex::setInitialDenseFactorization | ( | bool | onOff | ) |

Normally the first factorization does sparse coding because the factorization could be singular.

This allows initial dense factorization when it is known to be safe

Reimplemented in AbcSimplex.

bool ClpSimplex::initialDenseFactorization | ( |  | ) | const

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

int ClpSimplex::sequenceIn | ( |  | ) | const`[inline]`

Return sequence In or Out.

Reimplemented in AbcSimplex.

Definition at line 1046 of file ClpSimplex.hpp.

int ClpSimplex::sequenceOut | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1049 of file ClpSimplex.hpp.

void ClpSimplex::setSequenceIn | ( | int | sequence | ) | `[inline]`

Set sequenceIn or Out.

Reimplemented in AbcSimplex.

Definition at line 1053 of file ClpSimplex.hpp.

void ClpSimplex::setSequenceOut | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1056 of file ClpSimplex.hpp.

int ClpSimplex::directionIn | ( |  | ) | const`[inline]`

Return direction In or Out.

Definition at line 1060 of file ClpSimplex.hpp.

int ClpSimplex::directionOut | ( |  | ) | const`[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Definition at line 1063 of file ClpSimplex.hpp.

void ClpSimplex::setDirectionIn | ( | int | direction | ) | `[inline]`

Set directionIn or Out.

Definition at line 1067 of file ClpSimplex.hpp.

void ClpSimplex::setDirectionOut | ( | int | direction | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Definition at line 1070 of file ClpSimplex.hpp.

double ClpSimplex::valueOut | ( |  | ) | const`[inline]`

Value of Out variable.

Definition at line 1074 of file ClpSimplex.hpp.

void ClpSimplex::setValueOut | ( | double | value | ) | `[inline]`

Set value of out variable.

Definition at line 1078 of file ClpSimplex.hpp.

double ClpSimplex::dualOut | ( |  | ) | const`[inline]`

Dual value of Out variable.

Definition at line 1082 of file ClpSimplex.hpp.

void ClpSimplex::setDualOut | ( | double | value | ) | `[inline]`

Set dual value of out variable.

Definition at line 1086 of file ClpSimplex.hpp.

void ClpSimplex::setLowerOut | ( | double | value | ) | `[inline]`

Set lower of out variable.

Definition at line 1090 of file ClpSimplex.hpp.

void ClpSimplex::setUpperOut | ( | double | value | ) | `[inline]`

Set upper of out variable.

Definition at line 1094 of file ClpSimplex.hpp.

void ClpSimplex::setTheta | ( | double | value | ) | `[inline]`

Set theta of out variable.

Definition at line 1098 of file ClpSimplex.hpp.

int ClpSimplex::isColumn | ( | int | sequence | ) | const`[inline]`

Returns 1 if sequence indicates column.

Reimplemented in AbcSimplex.

Definition at line 1102 of file ClpSimplex.hpp.

int ClpSimplex::sequenceWithin | ( | int | sequence | ) | const`[inline]`

Returns sequence number within section.

Reimplemented in AbcSimplex.

Definition at line 1106 of file ClpSimplex.hpp.

double ClpSimplex::solution | ( | int | sequence | ) | `[inline]`

Return row or column values.

Reimplemented in AbcSimplex.

Definition at line 1110 of file ClpSimplex.hpp.

double& ClpSimplex::solutionAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column values.

Reimplemented in AbcSimplex.

Definition at line 1114 of file ClpSimplex.hpp.

double ClpSimplex::reducedCost | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1117 of file ClpSimplex.hpp.

double& ClpSimplex::reducedCostAddress | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1120 of file ClpSimplex.hpp.

double ClpSimplex::lower | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1123 of file ClpSimplex.hpp.

double& ClpSimplex::lowerAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column lower bound.

Reimplemented in AbcSimplex.

Definition at line 1127 of file ClpSimplex.hpp.

double ClpSimplex::upper | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1130 of file ClpSimplex.hpp.

double& ClpSimplex::upperAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column upper bound.

Reimplemented in AbcSimplex.

Definition at line 1134 of file ClpSimplex.hpp.

double ClpSimplex::cost | ( | int | sequence | ) | `[inline]`

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Reimplemented in AbcSimplex.

Definition at line 1137 of file ClpSimplex.hpp.

double& ClpSimplex::costAddress | ( | int | sequence | ) | `[inline]`

Return address of row or column cost.

Reimplemented in AbcSimplex.

Definition at line 1141 of file ClpSimplex.hpp.

double ClpSimplex::originalLower | ( | int | iSequence | ) | const`[inline]`

Return original lower bound.

Reimplemented in AbcSimplex.

Definition at line 1145 of file ClpSimplex.hpp.

double ClpSimplex::originalUpper | ( | int | iSequence | ) | const`[inline]`

Return original lower bound.

Reimplemented in AbcSimplex.

Definition at line 1151 of file ClpSimplex.hpp.

double ClpSimplex::theta | ( |  | ) | const`[inline]`

Theta (pivot change).

Definition at line 1157 of file ClpSimplex.hpp.

double ClpSimplex::bestPossibleImprovement | ( |  | ) | const`[inline]`

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).

Definition at line 1162 of file ClpSimplex.hpp.

ClpNonLinearCost* ClpSimplex::nonLinearCost | ( |  | ) | const`[inline]`

Return pointer to details of costs.

Definition at line 1166 of file ClpSimplex.hpp.

int ClpSimplex::moreSpecialOptions | ( |  | ) | const`[inline]`

Return more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - if factorization kept can still declare optimal at once 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible debug 32768 bit - do dual in netlibd 65536 (*3) initial stateDualColumn.

Definition at line 1189 of file ClpSimplex.hpp.

void ClpSimplex::setMoreSpecialOptions | ( | int | value | ) | `[inline]`

Set more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows).

Definition at line 1211 of file ClpSimplex.hpp.

void ClpSimplex::setFakeBound | ( | int | sequence,
|  | FakeBound | fakeBound |
| ) |  |  | `[inline]`

To flag a variable (not inline to allow for column generation).

Definition at line 1217 of file ClpSimplex.hpp.

FakeBound ClpSimplex::getFakeBound | ( | int | sequence | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1222 of file ClpSimplex.hpp.

void ClpSimplex::setRowStatus | ( | int | sequence,
|  | Status | newstatus |
| ) |  |  | `[inline]`

To flag a variable (not inline to allow for column generation).

Definition at line 1225 of file ClpSimplex.hpp.

Status ClpSimplex::getRowStatus | ( | int | sequence | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Definition at line 1230 of file ClpSimplex.hpp.

void ClpSimplex::setColumnStatus | ( | int | sequence,
|  | Status | newstatus |
| ) |  |  | `[inline]`

To flag a variable (not inline to allow for column generation).

Definition at line 1233 of file ClpSimplex.hpp.

Status ClpSimplex::getColumnStatus | ( | int | sequence | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Definition at line 1238 of file ClpSimplex.hpp.

void ClpSimplex::setPivoted | ( | int | sequence | ) | `[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1241 of file ClpSimplex.hpp.

void ClpSimplex::clearPivoted | ( | int | sequence | ) | `[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1244 of file ClpSimplex.hpp.

bool ClpSimplex::pivoted | ( | int | sequence | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1247 of file ClpSimplex.hpp.

void ClpSimplex::setFlagged | ( | int | sequence | ) |

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

void ClpSimplex::clearFlagged | ( | int | sequence | ) | `[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1252 of file ClpSimplex.hpp.

bool ClpSimplex::flagged | ( | int | sequence | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1255 of file ClpSimplex.hpp.

void ClpSimplex::setActive | ( | int | iRow | ) | `[inline]`

To say row active in primal pivot row choice.

Reimplemented in AbcSimplex.

Definition at line 1259 of file ClpSimplex.hpp.

void ClpSimplex::clearActive | ( | int | iRow | ) | `[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1262 of file ClpSimplex.hpp.

bool ClpSimplex::active | ( | int | iRow | ) | const`[inline]`

To flag a variable (not inline to allow for column generation).

Reimplemented in AbcSimplex.

Definition at line 1265 of file ClpSimplex.hpp.

void ClpSimplex::createStatus | ( |  | ) |

Set up status array (can be used by OsiClp).

Also can be used to set up all slack basis

Reimplemented in AbcSimplex.

void ClpSimplex::allSlackBasis | ( | bool | resetSolution = `false` | ) |

Sets up all slack basis and resets solution to as it was after initial load or readMps.

int ClpSimplex::lastBadIteration | ( |  | ) | const`[inline]`

So we know when to be cautious.

Definition at line 1276 of file ClpSimplex.hpp.

void ClpSimplex::setLastBadIteration | ( | int | value | ) | `[inline]`

Set so we know when to be cautious.

Definition at line 1280 of file ClpSimplex.hpp.

int ClpSimplex::progressFlag | ( |  | ) | const`[inline]`

Progress flag - at present 0 bit says artificials out.

Definition at line 1284 of file ClpSimplex.hpp.

ClpSimplexProgress* ClpSimplex::progress | ( |  | ) | `[inline]`

For dealing with all issues of cycling etc.

Definition at line 1288 of file ClpSimplex.hpp.

int ClpSimplex::forceFactorization | ( |  | ) | const`[inline]`

Force re-factorization early value.

Definition at line 1291 of file ClpSimplex.hpp.

void ClpSimplex::forceFactorization | ( | int | value | ) | `[inline]`

Force re-factorization early.

Definition at line 1295 of file ClpSimplex.hpp.

double ClpSimplex::rawObjectiveValue | ( |  | ) | const`[inline]`

Raw objective value (so always minimize in primal).

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1299 of file ClpSimplex.hpp.

void ClpSimplex::computeObjectiveValue | ( | bool | useWorkingSolution = `false` | ) |

Compute objective value from solution and put in objectiveValue_.

Reimplemented in AbcSimplex.

double ClpSimplex::computeInternalObjectiveValue | ( |  | ) |

Compute minimization objective value from internal solution without perturbation.

Reimplemented in AbcSimplex.

double* ClpSimplex::infeasibilityRay | ( | bool | fullRay = `false` | ) | const

Infeasibility/unbounded ray (NULL returned if none/wrong) Up to user to use delete [] on these arrays.

Reimplemented from ClpModel.

int ClpSimplex::numberExtraRows | ( |  | ) | const`[inline]`

Number of extra rows.

These are ones which will be dynamically created each iteration. This is for GUB but may have other uses.

Definition at line 1312 of file ClpSimplex.hpp.

int ClpSimplex::maximumBasic | ( |  | ) | const`[inline]`

Maximum number of basic variables - can be more than number of rows if GUB.

Definition at line 1317 of file ClpSimplex.hpp.

int ClpSimplex::baseIteration | ( |  | ) | const`[inline]`

Iteration when we entered dual or primal.

Definition at line 1321 of file ClpSimplex.hpp.

void ClpSimplex::generateCpp | ( | FILE * | fp,
|  | bool | defaultFactor = `false` |
| ) |  |  |

Create C++ lines to get to current state.

ClpFactorization* ClpSimplex::getEmptyFactorization | ( |  | ) |

Gets clean and emptyish factorization.

Reimplemented in AbcSimplex.

void ClpSimplex::setEmptyFactorization | ( |  | ) |

May delete or may make clean and emptyish factorization.

void ClpSimplex::moveInfo | ( | const ClpSimplex & | rhs,
|  | bool | justStatus = `false` |
| ) |  |  |

Move status and solution across.

Reimplemented in AbcSimplex.

void ClpSimplex::getBInvARow | ( | int | row,
|  | double * | z,
|  | double * | slack = `NULL` |
| ) |  |  |

Get a row of the tableau (slack part in slack if not NULL).

void ClpSimplex::getBInvRow | ( | int | row,
|  | double * | z |
| ) |  |  |

Get a row of the basis inverse.

void ClpSimplex::getBInvACol | ( | int | col,
|  | double * | vec |
| ) |  |  |

Get a column of the tableau.

void ClpSimplex::getBInvCol | ( | int | col,
|  | double * | vec |
| ) |  |  |

Get a column of the basis inverse.

void ClpSimplex::getBasics | ( | int * | index | ) |

Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).

void ClpSimplex::setObjectiveCoefficient | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set an objective function coefficient.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set an objective function coefficient.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1363 of file ClpSimplex.hpp.

void ClpSimplex::setColumnLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single column lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setColumnUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single column upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setColumnBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  |

Set a single column lower and upper bound.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setColumnSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  |

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set a single column lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1393 of file ClpSimplex.hpp.

void ClpSimplex::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline]`

Set a single column upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1398 of file ClpSimplex.hpp.

void ClpSimplex::setColBounds | ( | int | elementIndex,
|  | double | newlower,
|  | double | newupper |
| ) |  |  | `[inline]`

Set a single column lower and upper bound.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1403 of file ClpSimplex.hpp.

void ClpSimplex::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[inline]`

Set the bounds on a number of columns simultaneously
.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

Definition at line 1414 of file ClpSimplex.hpp.

void ClpSimplex::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single row lower bound
Use -DBL_MAX for -infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  |

Set a single row upper bound
Use DBL_MAX for infinity.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  |

Set a single row lower and upper bound.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  |

Set the bounds on a number of rows simultaneously
.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

void ClpSimplex::resize | ( | int | newNumberRows,
|  | int | newNumberColumns |
| ) |  |  |

Resizes rim part of model.

Reimplemented from ClpModel.

Reimplemented in AbcSimplex.

## Friends And Related Function Documentation

friend class OsiClpSolverInterface`[friend]`

Allow OsiClp certain perks.

Definition at line 1666 of file ClpSimplex.hpp.

void ClpSimplexUnitTest | ( | const std::string & | mpsDir | ) | `[friend]`

A function that tests the methods in the ClpSimplex class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

It also does some testing of ClpFactorization class

## Member Data Documentation

double ClpSimplex::bestPossibleImprovement_`[protected]`

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).

Definition at line 1457 of file ClpSimplex.hpp.

double ClpSimplex::zeroTolerance_`[protected]`

Zero tolerance.

Definition at line 1459 of file ClpSimplex.hpp.

int ClpSimplex::columnPrimalSequence_`[protected]`

Sequence of worst (-1 if feasible).

Definition at line 1461 of file ClpSimplex.hpp.

int ClpSimplex::rowPrimalSequence_`[protected]`

Sequence of worst (-1 if feasible).

Definition at line 1463 of file ClpSimplex.hpp.

double ClpSimplex::bestObjectiveValue_`[protected]`

"Best" objective value

Definition at line 1465 of file ClpSimplex.hpp.

int ClpSimplex::moreSpecialOptions_`[protected]`

More special options - see set for details.

Definition at line 1467 of file ClpSimplex.hpp.

int ClpSimplex::baseIteration_`[protected]`

Iteration when we entered dual or primal.

Definition at line 1469 of file ClpSimplex.hpp.

double ClpSimplex::primalToleranceToGetOptimal_`[protected]`

Primal tolerance needed to make dual feasible (<largeTolerance).

Definition at line 1471 of file ClpSimplex.hpp.

double ClpSimplex::largeValue_`[protected]`

Large bound value (for complementarity etc).

Definition at line 1473 of file ClpSimplex.hpp.

double ClpSimplex::largestPrimalError_`[protected]`

Largest error on Ax-b.

Definition at line 1475 of file ClpSimplex.hpp.

double ClpSimplex::largestDualError_`[protected]`

Largest error on basic duals.

Definition at line 1477 of file ClpSimplex.hpp.

double ClpSimplex::alphaAccuracy_`[protected]`

For computing whether to re-factorize.

Definition at line 1479 of file ClpSimplex.hpp.

double ClpSimplex::dualBound_`[protected]`

Dual bound.

Definition at line 1481 of file ClpSimplex.hpp.

double ClpSimplex::alpha_`[protected]`

Alpha (pivot element).

Definition at line 1483 of file ClpSimplex.hpp.

double ClpSimplex::theta_`[protected]`

Theta (pivot change).

Definition at line 1485 of file ClpSimplex.hpp.

double ClpSimplex::lowerIn_`[protected]`

Lower Bound on In variable.

Definition at line 1487 of file ClpSimplex.hpp.

double ClpSimplex::valueIn_`[protected]`

Value of In variable.

Definition at line 1489 of file ClpSimplex.hpp.

double ClpSimplex::upperIn_`[protected]`

Upper Bound on In variable.

Definition at line 1491 of file ClpSimplex.hpp.

double ClpSimplex::dualIn_`[protected]`

Reduced cost of In variable.

Definition at line 1493 of file ClpSimplex.hpp.

double ClpSimplex::lowerOut_`[protected]`

Lower Bound on Out variable.

Definition at line 1495 of file ClpSimplex.hpp.

double ClpSimplex::valueOut_`[protected]`

Value of Out variable.

Definition at line 1497 of file ClpSimplex.hpp.

double ClpSimplex::upperOut_`[protected]`

Upper Bound on Out variable.

Definition at line 1499 of file ClpSimplex.hpp.

double ClpSimplex::dualOut_`[protected]`

Infeasibility (dual) or ? (primal) of Out variable.

Definition at line 1501 of file ClpSimplex.hpp.

double ClpSimplex::dualTolerance_`[protected]`

Current dual tolerance for algorithm.

Definition at line 1503 of file ClpSimplex.hpp.

double ClpSimplex::primalTolerance_`[protected]`

Current primal tolerance for algorithm.

Definition at line 1505 of file ClpSimplex.hpp.

double ClpSimplex::sumDualInfeasibilities_`[protected]`

Sum of dual infeasibilities.

Definition at line 1507 of file ClpSimplex.hpp.

double ClpSimplex::sumPrimalInfeasibilities_`[protected]`

Sum of primal infeasibilities.

Definition at line 1509 of file ClpSimplex.hpp.

double ClpSimplex::infeasibilityCost_`[protected]`

Weight assigned to being infeasible in primal.

Definition at line 1511 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedDualInfeasibilities_`[protected]`

Sum of Dual infeasibilities using tolerance based on error in duals.

Definition at line 1513 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedPrimalInfeasibilities_`[protected]`

Sum of Primal infeasibilities using tolerance based on error in primals.

Definition at line 1515 of file ClpSimplex.hpp.

double ClpSimplex::acceptablePivot_`[protected]`

Acceptable pivot value just after factorization.

Definition at line 1517 of file ClpSimplex.hpp.

double* ClpSimplex::lower_`[protected]`

Working copy of lower bounds (Owner of arrays below).

Definition at line 1519 of file ClpSimplex.hpp.

double* ClpSimplex::rowLowerWork_`[protected]`

Row lower bounds - working copy.

Definition at line 1521 of file ClpSimplex.hpp.

double* ClpSimplex::columnLowerWork_`[protected]`

Column lower bounds - working copy.

Definition at line 1523 of file ClpSimplex.hpp.

double* ClpSimplex::upper_`[protected]`

Working copy of upper bounds (Owner of arrays below).

Definition at line 1525 of file ClpSimplex.hpp.

double* ClpSimplex::rowUpperWork_`[protected]`

Row upper bounds - working copy.

Definition at line 1527 of file ClpSimplex.hpp.

double* ClpSimplex::columnUpperWork_`[protected]`

Column upper bounds - working copy.

Definition at line 1529 of file ClpSimplex.hpp.

double* ClpSimplex::cost_`[protected]`

Working copy of objective (Owner of arrays below).

Definition at line 1531 of file ClpSimplex.hpp.

double* ClpSimplex::rowObjectiveWork_`[protected]`

Row objective - working copy.

Definition at line 1533 of file ClpSimplex.hpp.

double* ClpSimplex::objectiveWork_`[protected]`

Column objective - working copy.

Definition at line 1535 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::rowArray_[6]`[protected]`

Useful row length arrays.

Definition at line 1537 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::columnArray_[6]`[protected]`

Useful column length arrays.

Definition at line 1539 of file ClpSimplex.hpp.

int ClpSimplex::sequenceIn_`[protected]`

Sequence of In variable.

Definition at line 1541 of file ClpSimplex.hpp.

int ClpSimplex::directionIn_`[protected]`

Direction of In, 1 going up, -1 going down, 0 not a clude.

Definition at line 1543 of file ClpSimplex.hpp.

int ClpSimplex::sequenceOut_`[protected]`

Sequence of Out variable.

Definition at line 1545 of file ClpSimplex.hpp.

int ClpSimplex::directionOut_`[protected]`

Direction of Out, 1 to upper bound, -1 to lower bound, 0 - superbasic.

Definition at line 1547 of file ClpSimplex.hpp.

int ClpSimplex::pivotRow_`[protected]`

Pivot Row.

Definition at line 1549 of file ClpSimplex.hpp.

int ClpSimplex::lastGoodIteration_`[protected]`

Last good iteration (immediately after a re-factorization).

Definition at line 1551 of file ClpSimplex.hpp.

double* ClpSimplex::dj_`[protected]`

Working copy of reduced costs (Owner of arrays below).

Definition at line 1553 of file ClpSimplex.hpp.

double* ClpSimplex::rowReducedCost_`[protected]`

Reduced costs of slacks not same as duals (or - duals).

Definition at line 1555 of file ClpSimplex.hpp.

double* ClpSimplex::reducedCostWork_`[protected]`

Possible scaled reduced costs.

Definition at line 1557 of file ClpSimplex.hpp.

double* ClpSimplex::solution_`[protected]`

Working copy of primal solution (Owner of arrays below).

Definition at line 1559 of file ClpSimplex.hpp.

double* ClpSimplex::rowActivityWork_`[protected]`

Row activities - working copy.

Definition at line 1561 of file ClpSimplex.hpp.

double* ClpSimplex::columnActivityWork_`[protected]`

Column activities - working copy.

Definition at line 1563 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilities_`[protected]`

Number of dual infeasibilities.

Definition at line 1565 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilitiesWithoutFree_`[protected]`

Number of dual infeasibilities (without free).

Definition at line 1567 of file ClpSimplex.hpp.

int ClpSimplex::numberPrimalInfeasibilities_`[protected]`

Number of primal infeasibilities.

Definition at line 1569 of file ClpSimplex.hpp.

int ClpSimplex::numberRefinements_`[protected]`

How many iterative refinements to do.

Definition at line 1571 of file ClpSimplex.hpp.

ClpDualRowPivot* ClpSimplex::dualRowPivot_`[protected]`

dual row pivot choice

Definition at line 1573 of file ClpSimplex.hpp.

ClpPrimalColumnPivot* ClpSimplex::primalColumnPivot_`[protected]`

primal column pivot choice

Definition at line 1575 of file ClpSimplex.hpp.

int* ClpSimplex::pivotVariable_`[protected]`

Basic variables pivoting on which rows.

Definition at line 1577 of file ClpSimplex.hpp.

ClpFactorization* ClpSimplex::factorization_`[protected]`

factorization

Definition at line 1579 of file ClpSimplex.hpp.

double* ClpSimplex::savedSolution_`[protected]`

Saved version of solution.

Definition at line 1581 of file ClpSimplex.hpp.

int ClpSimplex::numberTimesOptimal_`[protected]`

Number of times code has tentatively thought optimal.

Definition at line 1583 of file ClpSimplex.hpp.

ClpDisasterHandler* ClpSimplex::disasterArea_`[protected]`

Disaster handler.

Definition at line 1585 of file ClpSimplex.hpp.

int ClpSimplex::changeMade_`[protected]`

If change has been made (first attempt at stopping looping).

Definition at line 1587 of file ClpSimplex.hpp.

int ClpSimplex::algorithm_`[protected]`

Algorithm >0 == Primal, <0 == Dual.

Definition at line 1589 of file ClpSimplex.hpp.

int ClpSimplex::forceFactorization_`[protected]`

Now for some reliability aids This forces re-factorization early.

Definition at line 1592 of file ClpSimplex.hpp.

int ClpSimplex::perturbation_`[protected]`

Perturbation: -50 to +50 - perturb by this power of ten (-6 sounds good) 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100.

Definition at line 1600 of file ClpSimplex.hpp.

unsigned char* ClpSimplex::saveStatus_`[protected]`

Saved status regions.

Definition at line 1602 of file ClpSimplex.hpp.

ClpNonLinearCost* ClpSimplex::nonLinearCost_`[protected]`

Very wasteful way of dealing with infeasibilities in primal.

However it will allow non-linearities and use of dual analysis. If it doesn't work it can easily be replaced.

Definition at line 1607 of file ClpSimplex.hpp.

int ClpSimplex::lastBadIteration_`[protected]`

So we know when to be cautious.

Definition at line 1609 of file ClpSimplex.hpp.

int ClpSimplex::lastFlaggedIteration_`[protected]`

So we know when to open up again.

Definition at line 1611 of file ClpSimplex.hpp.

int ClpSimplex::numberFake_`[protected]`

Can be used for count of fake bounds (dual) or fake costs (primal).

Definition at line 1613 of file ClpSimplex.hpp.

int ClpSimplex::numberChanged_`[protected]`

Can be used for count of changed costs (dual) or changed bounds (primal).

Definition at line 1615 of file ClpSimplex.hpp.

int ClpSimplex::progressFlag_`[protected]`

Progress flag - at present 0 bit says artificials out, 1 free in.

Definition at line 1617 of file ClpSimplex.hpp.

int ClpSimplex::firstFree_`[protected]`

First free/super-basic variable (-1 if none).

Definition at line 1619 of file ClpSimplex.hpp.

int ClpSimplex::numberExtraRows_`[protected]`

Number of extra rows.

These are ones which will be dynamically created each iteration. This is for GUB but may have other uses.

Definition at line 1623 of file ClpSimplex.hpp.

int ClpSimplex::maximumBasic_`[protected]`

Maximum number of basic variables - can be more than number of rows if GUB.

Definition at line 1626 of file ClpSimplex.hpp.

int ClpSimplex::dontFactorizePivots_`[protected]`

If may skip final factorize then allow up to this pivots (default 20).

Definition at line 1628 of file ClpSimplex.hpp.

double ClpSimplex::incomingInfeasibility_`[protected]`

For advanced use.

When doing iterative solves things can get nasty so on values pass if incoming solution has largest infeasibility < incomingInfeasibility throw out variables from basis until largest infeasibility < allowedInfeasibility. if allowedInfeasibility>= incomingInfeasibility this is always possible altough you may end up with an all slack basis.

Defaults are 1.0,10.0

Definition at line 1638 of file ClpSimplex.hpp.

double ClpSimplex::allowedInfeasibility_`[protected]`

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).

Definition at line 1639 of file ClpSimplex.hpp.

int ClpSimplex::automaticScale_`[protected]`

Automatic scaling of objective and rhs and bounds.

Definition at line 1641 of file ClpSimplex.hpp.

int ClpSimplex::maximumPerturbationSize_`[protected]`

Maximum perturbation array size (take out when code rewritten).

Definition at line 1643 of file ClpSimplex.hpp.

double* ClpSimplex::perturbationArray_`[protected]`

Perturbation array (maximumPerturbationSize_).

Definition at line 1645 of file ClpSimplex.hpp.

ClpSimplex* ClpSimplex::baseModel_`[protected]`

A copy of model with certain state - normally without cuts.

Definition at line 1647 of file ClpSimplex.hpp.

ClpSimplexProgress ClpSimplex::progress_`[protected]`

For dealing with all issues of cycling etc.

Definition at line 1649 of file ClpSimplex.hpp.

int ClpSimplex::abcState_`[protected]`

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual).

Definition at line 1658 of file ClpSimplex.hpp.

int ClpSimplex::spareIntArray_[4]`[mutable]`

Spare int array for passing information [0]!=0 switches on.

Definition at line 1661 of file ClpSimplex.hpp.

double ClpSimplex::spareDoubleArray_[4]`[mutable]`

Spare double array for passing information [0]!=0 switches on.

Definition at line 1663 of file ClpSimplex.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Alps-1.4.6/Clp/src/ClpSimplex.hpp